<template>
  <input
    type="submit"
    :class="[$style[theme], $style.buttonDefaults]"
    :disabled="disabled"
    @click="clickHandler"
    :value="value"
  />
</template>

<script lang="ts">
import Vue from "vue";

export default Vue.extend({
  name: "BaseInputSubmit",

  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },

    value: {
      type: String,
      required: true,
      default: "submit"
    },
    theme: {
      type: String,
      required: false,
      default: "primary",
      validator: function(value: string) {
        const accepteableValues = [
          "primary",
          "transparentPrimaryBorder",
          "transparent",
          "dark"
        ];
        return accepteableValues.indexOf(value) !== -1;
      }
    }
  },
  data: function() {
    return {
      selectedOption: null
    };
  },
  computed: {},
  methods: {
    clickHandler: function() {
      this.$emit("onClick");
    }
  }
});
</script>

<style module lang="scss">
.transparent {
  composes: button--transparent;
}
.dark {
  composes: button--dark;
}
.primary {
  composes: button--primary;
}
.transparentPrimaryBorder {
  composes: button--transparent-primary-border;
}
.buttonText {
  margin-left: 0.5rem;
}

@media screen and (max-width: $device-size--mobile-large) {
  .buttonDefaults {
    width: 100%;
  }
}
</style>
